// ===================================================================
// John Conneely <jconneely@RiverStarSoftware.com>
// Randy Meacham <rmeacham@RiverStarSoftware.com>
// ===================================================================




function objectClick(objectType, objectValue, validateData, branchFlag, skipValidation, threadNum, objectParent, cs)
{
    RSStudio.ui.objectClick(objectType, objectValue, validateData, branchFlag, skipValidation, objectParent, cs);
}

function matrixClick(clickType, matrixName, objectRow, objectCol, branchFlag, threadNum)
{
    RSStudio.ui.matrixClick(clickType, matrixName, objectRow, objectCol, branchFlag);
}

var getXmlHttp = function(){ //Factory method
//By Ross Harmes and Dustin Diaz
//Pro Javascript Design Patterns
//www.apress.com
//jsdesignpatterns.com 
    var methods = [
        function() {return new XMLHttpRequest();},
        function() {return new ActiveXObject('Msxml2.XMLHTTP');},
        function() {return new ActiveXObject('Microsoft.XMLHTTP');}
    ];
    
    for(var i=0, len=methods.length; i<len; i++){
        try{
            methods[i]();//Attempt to use
        }catch(e){
            continue; //Try next method
        }
        //If we reached this point, method[i] worked
        return createXhrObject= methods[i];//Memorize the method.
    }
    //If we reach this point, none of the methods worked.
    throw new Error('Could not create an XHR object.');
}();//Execute on load 


function formSubmit(theForm)
{
	document.body.style.cursor='wait';
	RSStudioPage.PageControl.pageLock = 1;
    theForm.submit();
}



function getNodeByTagName(parentNode, tagName)
{

    if( parentNode == null )
    {
        return null;
    }
    
    var childNode = parentNode.firstChild;
    while( childNode != null )
    {
        if( childNode.nodeType == 1 && childNode.nodeName == tagName )
        {
            return childNode;
        }
        childNode = childNode.nextSibling;
    }
    return null;
}

function getFirstChildNode(parentNode)
{
    if( parentNode == null )
    {
        return null;
    }
    
    var childNode = parentNode.firstChild;
    while( childNode != null )
    {
        if( childNode.nodeType == 1 )
        {
            return childNode;
        }
        childNode = childNode.nextSibling;
    }
    return null;

}


function getNextSiblingNode(currentNode)
{
    if( currentNode == null )
    {
        return null;
    }
    
    var nextNode = currentNode.nextSibling;
    while( nextNode != null )
    {
        if( nextNode.nodeType == 1 )
        {
            return nextNode;
        }
        nextNode = nextNode.nextSibling;
    }
    return null;

}

function getNodeValue(node)
{
    if( node == null )
    {
        return null;
    }
    
    var value = "";
    textNode = node.firstChild;
    while( textNode != null )
    {
        if( textNode.nodeType == 3 )
        {
            value += textNode.nodeValue;
        }
        textNode = textNode.nextSibling;
    }
    return value;
}


function confirmObjectClick(objectType, objectValue, confirmText, validateData, branchFlag, skipValidation, objectParent)
{

    RSStudio.ui.confirmObjectClick(objectType, objectValue, confirmText, validateData, branchFlag, skipValidation, objectParent);

}

function getPageTitle()
{
    var metadata = document.getElementsByTagName("meta"); 
    var len = metadata.length;
    var title = "";
    for (var i = 0; i < len; i++) 
    {     
        if (metadata[i].name == 'PageLayoutLabel') 
        {         
            title = metadata[i].content;
            break;
        }
    }
    return title;
}

function WWGUserAlert(msg)
{
	if( msg != "" )
	{
    		RSStudio.userAlert( msg );
	}
}


function WWGChangeImage(objectName, imageName)
{
	if (document.images)
	{
		currentImage = document.images[objectName];
		currentImage.src = imageName;
	}
}


function WWGCallIfExists(func_name)
{
    if (self[func_name])
    {
	    eval(func_name + "()");
    }
}


function replaceSpecialChars(parmC)
{

    var c = parmC;

    if (parmC == null)
    {
        return null;
    }

    c = c.replace(/&/g, "&amp;");
	c = c.replace(/>/g, "&gt;");
	c = c.replace(/</g, "&lt;");
	c = c.replace(/"/g, "&quot;");
	c = c.replace(/'/g, "&apos;");
	
	
	return c;
}




function WWGOpenFileUploadWindow(fieldName, saveFolder, codeTarget)
{
	var width = 410;
	var height = 100;
	var fontVal = "font: normal 11px Verdana, Geneva, Arial, Helvetica, sans-serif;";
  	var left = Math.floor( (screen.width - width) / 2);
   	var top = Math.floor( (screen.height - height) / 2);
	var winOps = "status=1,location=0,resizeable=0,toolbar=0,width=" + width + ",height=" + height + ",left=" + left + ",top=" + top;
	var winRef = window.open("","mywin",winOps);
	winRef.document.writeln("<HTML><HEAD><TITLE></TITLE></HEAD><BODY>");
	winRef.document.writeln("<FORM METHOD=\"POST\" ENCTYPE=\"multipart/form-data\" ACTION=\"WWGFileUpload." + codeTarget + "\" NAME=\"main1\">");
	winRef.document.writeln("<div id=\"displayArea\" style=\"display:block\">");
	winRef.document.writeln("<input type=hidden name=fieldName value=\"" + fieldName + "\">");
	winRef.document.writeln("<input type=hidden name=saveFolder value=\"" + saveFolder + "\">");
	winRef.document.writeln("<TABLE style=\"" + fontVal + "\" BORDER=1>");
	winRef.document.writeln("<TR><TH align=left style=\"background-color=#006699;color=#FFFFFF;" + fontVal + "\">Select a file to upload</TH></TR>");
	winRef.document.writeln("<TR><TD><INPUT style=\"" + fontVal + "\" TYPE=FILE SIZE=50 NAME=\"file\"></TD></TR>");
	winRef.document.writeln("</TABLE><INPUT style=\"" + fontVal + "\" TYPE=SUBMIT VALUE=\"Upload\" onClick='swapDisplay();'>");
	winRef.document.writeln("</div>");
	winRef.document.writeln("<div id=\"messageArea\" style=\"display:none\">");
	winRef.document.writeln("<B>Please wait while your file is uploaded...</B><BR>This window will close when the upload is complete.");
	winRef.document.writeln("</div>");
	winRef.document.writeln("</FORM></BODY></HTML>");
	winRef.document.writeln("<scri" + "pt language=\"JavaScript\">");
	winRef.document.writeln("function swapDisplay()");
	winRef.document.writeln("{");
	winRef.document.writeln("var objBranch = document.getElementById(\"displayArea\").style;");
	winRef.document.writeln("var objMessage = document.getElementById(\"messageArea\").style;");
	winRef.document.writeln("objBranch.display=\"none\";");
	winRef.document.writeln("objMessage.display=\"block\";");
	winRef.document.writeln("}");
	winRef.document.writeln("</script>");
}

function WWGChangeElementClassByName(tagName, oldclass, newclass)
{
	var elms = document.getElementsByTagName(tagName);

	for( var i = 0; i < elms.length; i++ )
	{
		if( elms[i].className == oldclass )
		{
			elms[i].className = newclass;
		}
	}
}

function WWGChangeElementClassById(id, newclass)
{
	var elm = document.getElementById(id);
    elm.className = newclass;
}

function WWGHideElementByName(tagName, className, hideIt)
{
	var elms = document.getElementsByTagName(tagName);

	for( var i = 0; i < elms.length; i++ )
	{
	    var classes = elms[i].className.split(" ");
	    
	    for( var j = 0; j < classes.length; j++ )
	    {
		    if( classes[j] == className )
		    {
			    WWGHideElement( elms[i], hideIt );
			    break;
		    }
		}
	}
}


function WWGHideElementById(id, hideIt)
{
	var elm = document.getElementById(id);
	if( elm != null )
	{
	    WWGHideElement( elm, hideIt );
	}
}

function WWGHideElement(elm, hideIt)
{
	if( hideIt )
	{
	    var classes = elm.className.split(" ");
	    var newClass = "";
	    for( var i = 0; i < classes.length; i++ )
	    {
	        if( classes[i] == "WWGHideElement" )
	        {
	            return;
	        }
	    }
	    if( elm.className != "" )
	    {
	        elm.className += " ";
	    }
	    elm.className += "WWGHideElement";
	}
	else
	{
	    var classes = elm.className.split(" ");
	    var newClass = "";
	    for( var i = 0; i < classes.length; i++ )
	    {
	        if( classes[i] != "WWGHideElement" )
	        {
	            if( newClass != "" )
	            {
	                newClass += " ";
	            }
	            newClass += classes[i];
	        }
	    }
	    elm.className = newClass;
	}
	        
}

function pageIsLocked(threadNum)
{
    if( RSStudioPage.PageControl.pageLock > 0)
    {
        return true;
    }
    else
    {
        return false;
    }
} 
